/******************************************************************************
	AVR ATMega328
	Push Button (UP/DOWN/LEFT/RIGHT/A/B) Module
	Using Input Port
******************************************************************************/
#include	<avr/io.h>

// Global Button Status
uint8_t	btnStatus  = 0;
uint8_t	btnOnFlag  = 0;
uint8_t	btnOffFlag = 0;
uint8_t	btnRepeatL = 0;
uint8_t	btnRepeatR = 0;

void buttonManager(void)
{
	static uint8_t repeatCounterL = 0;
	static uint8_t repeatCounterR = 0;
	static uint8_t prevBtnStatus = 0;

	btnStatus  = ((~PINC) & 0x03F);
	btnOnFlag  = (btnStatus ^ prevBtnStatus) & ( btnStatus);
	btnOffFlag = (btnStatus ^ prevBtnStatus) & (~btnStatus);
	prevBtnStatus = btnStatus;

	// Key Repeat for UP/DOWN/LEFT/RIGHT
	if( btnStatus & 0x0F ){
		if( repeatCounterL < 255 ) repeatCounterL++;
	}
	else{
		repeatCounterL = 0;
	}
	if(repeatCounterL == 1 || repeatCounterL > 10){
		btnRepeatL = btnStatus & 0x0F;
	}
	else{
		btnRepeatL = 0;
	}

	// Key Repeat for OK/CANCEL
	if( btnStatus & 0x30 ){
		if( repeatCounterR < 255 ) repeatCounterR++;
	}
	else{
		repeatCounterR = 0;
	}
	if(repeatCounterR == 1 || repeatCounterR > 10){
		btnRepeatR = btnStatus & 0x30;
	}
	else{
		btnRepeatR = 0;
	}
}


