#ifndef GRAPH_H_
#define GRAPH_H_

#ifdef __LIB_MODULE__
#define EXTERN
#else
#define EXTERN	extern
#endif

#define SCROLL_LEFT		1
#define SCROLL_RIGHT	2
#define SCROLL_UP		3
#define SCROLL_DOWN		4

#define DRAW_MODE_PUT	1
#define DRAW_MODE_OR	2
#define DRAW_MODE_AND	3

EXTERN void lcdInit(void);
EXTERN void lcdRefresh(void);

EXTERN uint8_t cgGetChar(uint8_t x, uint8_t y);
EXTERN void cgPutChar(uint8_t x, uint8_t y, char c);
EXTERN void cgPrint(uint8_t x, uint8_t y, const char *str);
EXTERN void cgFill(uint8_t c);
EXTERN void cgScroll(uint8_t dir);

EXTERN void fbClear(void);
EXTERN void fbPSet(int x, int y, unsigned char color);
EXTERN void fbDrawChar(int x, int y, unsigned char charCode, uint8_t mode);
EXTERN void fbDrawStr(int x, int y, const char *str, unsigned char mode);
EXTERN void fbDrawCGRAM(void);
EXTERN void fbDrawCGRAMOffset(int8_t x, int8_t y);
EXTERN void fbDrawLine(int x1, int y1, int x2, int y2, unsigned char color);
EXTERN void fbDrawRect(int x, int y, unsigned int width, unsigned int height, unsigned char color);
EXTERN void fbFillRect(int x, int y, unsigned int width, unsigned int height, unsigned char color);

#endif /* GRAPH_H_ */